# 部署 letsencrypt

- 为域名 x1.xx.com 和 x2.xx.com 申请 ssl 证书，并在每月的 31 号晚上十一点更新一次
- 为域名 \*.xxx.com 和 \*.yyy.com 申请 ssl 证书，并在每月的 31 号晚上十点更新一次
- 根据实际环境修改
    - docker-compose.yml

- 创建目录
    ```
    grep '\<source:' docker-compose.yml | cut -d: -f2 | xargs mkdir -p
    ```

- 获取通配域名的证书时，需要设置 TXT 解析记录，这里配合脚本实现自动添加和更新
    - 调用腾讯云接口设置/更新 TXT 解析记录
        ```
        cp tencent-api.sh letsencrypt-wildcard/etc/manual-hook.sh
        # 修改脚本，替换成自己的阿里云 access key 信息
        #ACCESS_KEY_ID='aliyun access key id'
        #ACCESS_KEY_SECRET='aliyun access key secret'
        ```

    - 调用阿里云接口设置/更新 TXT 解析记录
        ```
        cp aliyun-api.sh letsencrypt-wildcard/etc/manual-hook.sh
        # 修改脚本，替换成自己的腾讯云 secret 信息
        #SECRET_ID='tencent secret id'
        #SECRET_KEY='tencent secret key'
        ```

- 手动启动，等待容器停止后，证书申请完成
    ```
    docker-compose up -d
    ```

- 创建定时任务
    ```
    0 23 31 * * docker-compose -f /compose/docker-compose.yml up letsencrypt
    0 22 31 * * docker-compose -f /compose/docker-compose.yml up letsencrypt-wildcard
    ```

